<?php
/*
Plugin Name: SimplyCaptcha WordPress Plugin
Plugin URI: http://www.simplycaptcha.com
Description: This Plugin uses the SimplyCaptcha system for Bot prevention and Spam Protection.
Version: 1.0
Author: Alan pinnt
Author URI: http://www.alanpinnt.com/
License: GPL3
    Copyright 2012 Alan Pinnt www.alanpinnt.com
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 3, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

define('SIMPLYCAP_PLUGIN_NAME', 'SimplyCaptcha WordPress Plugin');
define('SIMPLYCAP_PLUGIN_URI', 'http://www.simplycaptcha.com/');
define('SIMPLYCAP_VERSION', '1.0');
define('SIMPLYCAP_AUTHOR', 'Alan Pinnt');
define('SIMPLYCAP_AUTHOR_URI', 'http://www.alanpinnt.com/');

define( 'SIMPLYCAP_URL', plugin_dir_url(__FILE__) );
define( 'SIMPLYCAP_PATH', plugin_dir_path(__FILE__) );
define( 'SIMPLYCAP_BASENAME', plugin_basename( __FILE__ ) );

////settings
function register_simplycaptcha_settings() {
	//register our settings
	register_setting('simplycap-settings-group', 'simplycap_key');
	register_setting('simplycap-settings-group', 'simplycap_website');
	register_setting('simplycap-settings-group', 'simplycap_registerform');
	register_setting('simplycap-settings-group', 'simplycap_commentform');
	register_setting('simplycap-settings-group', 'simplycap_lostpassform');
	register_setting('simplycap-settings-group', 'simplycap_loginform');
    register_setting('simplycap-settings-group', 'simplycap_hideregister');
    register_setting('simplycap-settings-group', 'simplycap_usesecurity');
}

add_action( 'admin_init', 'register_simplycaptcha_settings' );


if ( ! function_exists ( 'simplycap_header' ) ) {
	function simplycap_header() {
		wp_register_style( 'simplycapcss', plugins_url( 'css/style.css', __FILE__ ) );
		wp_enqueue_style( 'simplycapcss' );
	}
}


add_action( 'admin_enqueue_scripts', 'simplycap_header' );
add_action( 'wp_enqueue_scripts', 'simplycap_header' );


function simplycap_plugin_action_links( $links, $file ) {
	static $this_plugin;
	if ( ! $this_plugin ) $this_plugin = plugin_basename(__FILE__);

	if ( $file == $this_plugin ){
			 $settings_link = '<a href="admin.php?page=simplycaptcha">' . __( 'Settings', 'SimplyCaptcha' ) . '</a>';
			 array_unshift( $links, $settings_link );
		}
	return $links;
} 


function simplycap_register_plugin_links($links, $file) {
	$base = plugin_basename(__FILE__);
	if ($file == $base) {
		$links[] = '<a href="admin.php?page=simplycaptcha">' . __( 'Settings', 'SimplyCaptcha' ) . '</a>';
		$links[] = '<a href="http://wordpress.org/extend/plugins/captcha/faq/" target="_blank">' . __( 'FAQ', 'captcha' ) . '</a>';
		$links[] = '<a href="http://simplycaptcha.com/">' . __( 'Support', 'captcha' ) . '</a>';
	}
	return $links;
}


add_filter( 'plugin_action_links', 'simplycap_plugin_action_links', 10, 2 );

add_filter( 'plugin_row_meta', 'simplycap_register_plugin_links', 10, 2 );


function simplycaptcha_get($website,$key) {
    global $simplycaptcha_get_tag, $simplycaptcha_get_question,$simplycaptcha_get_error,$simplycaptcha_get_success;
        
    $c = curl_init();
    curl_setopt($c, CURLOPT_URL, 'http://www.simplycaptcha.com/captcha/request.php');
    curl_setopt($c, CURLOPT_POST, true);
    
    if (get_option('simplycap_usesecurity') == '1') {
    $browser = $_SERVER['HTTP_USER_AGENT'];
    $ip=$_SERVER['REMOTE_ADDR'];
    curl_setopt($c, CURLOPT_POSTFIELDS, 'website='.$website.'&key='.$key.'&security=1&agent='.$browser.'&ip='.$ip.'');
    } else {
    curl_setopt($c, CURLOPT_POSTFIELDS, 'website='.$website.'&key='.$key.'&security=0');      
    }
    curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
    $response = curl_exec($c);
    curl_close ($c);

    $obj = json_decode($response);
    
    $simplycaptcha_get_tag = $obj->{'tag'};
    $simplycaptcha_get_question = $obj->{'question'};
    $simplycaptcha_get_error = $obj->{'error'};
    $simplycaptcha_get_success = $obj->{'success'};

}


function simplycaptcha_validate($website,$tag,$answer) {
    global $simplycaptcha_validate_error,$simplycaptcha_validate_success;
    
    $c = curl_init();
    curl_setopt($c, CURLOPT_URL, 'http://www.simplycaptcha.com/captcha/validate.php');
    curl_setopt($c, CURLOPT_POST, true);
    curl_setopt($c, CURLOPT_POSTFIELDS, 'website='.$website.'&key='.get_option('simplycap_key').'&tag='.$tag.'&answer='.$answer.'');
    curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
    $response = curl_exec($c);
    curl_close ($c);

    $obj = json_decode($response);

    $simplycaptcha_validate_error = $obj->{'error'};
    $simplycaptcha_validate_success = $obj->{'success'};
}

if(get_option('simplycap_loginform') == 1) {
	add_action( 'login_form', 'simplycap_login_form' );
	add_filter( 'login_errors', 'simplycap_login_post' );
	add_filter( 'login_redirect', 'simplycap_login_check', 10, 6 ); 
}
	
if(get_option('simplycap_commentform') == 1) {
    	global $wp_version;
	if( version_compare($wp_version,'3','>=') ) { // wp 3.0 +
		add_action( 'comment_form_after_fields', 'simplycap_comment_form_wp3', 1 );
		add_action( 'comment_form_logged_in_after', 'simplycap_comment_form_wp3', 1 );
	}
	add_action( 'comment_form', 'simplycap_comment_form' );
	add_filter( 'preprocess_comment', 'simplycap_comment_post' );	
}
// Add captcha in the register form
if(get_option('simplycap_registerform') == 1) {
	add_action( 'register_form', 'simplycap_register_form' );
	add_action( 'register_post', 'simplycap_register_post', 10, 3 );
	add_action( 'signup_extra_fields', 'simplycap_register_form' );
	add_filter( 'wpmu_validate_user_signup', 'simplycap_register_validate' );
}
// Add captcha into lost password form
if(get_option('simplycap_lostpassform') == 1) {
	add_action( 'lostpassword_form', 'simplycap_register_form' );
	add_action( 'lostpassword_post', 'simplycap_lostpassword_post', 10, 3 );
}


function simplycap_comment_form_wp3() {
	// skip captcha if user is logged in and the settings allow
	if ( is_user_logged_in() && get_option('simplycap_hideregister') == 1) {
		return true;
	} else {
    ////Call SimplyCaptcha Function
    global $simplycaptcha_get_question,$simplycaptcha_get_tag,$simplycaptcha_get_error,$simplycaptcha_get_success;
    simplycaptcha_get(get_option('simplycap_website'),get_option('simplycap_key'));

    if ($simplycaptcha_get_success == 'false') {
        print 'There was an error: '.$simplycaptcha_get_error;
        
        remove_action( 'comment_form', 'simplycap_comment_form' );
    } else {
	   echo '<p class="simplycap_block">';
	       echo '<label><input type="hidden" name="simplycaptcha-tag" value="'.$simplycaptcha_get_tag.'">'.$simplycaptcha_get_question.'?</label>';
           echo ' <input type="text" size="30" name="simplycaptcha-answer">';
           echo '<br />';
	       echo '<a href="http://www.simplycaptcha.com">SimplyCaptcha</a></p>';

        remove_action( 'comment_form', 'simplycap_comment_form' );

    	return true;
        }
    }
}


function simplycap_comment_form() {
	// skip captcha if user is logged in and the settings allow
	if ( is_user_logged_in() && get_option('simplycap_hideregister') == 1) {
		return true;
	} else {
    ////Call SimplyCaptcha Function
    global $simplycaptcha_get_question,$simplycaptcha_get_tag,$simplycaptcha_get_error,$simplycaptcha_get_success;
    simplycaptcha_get(get_option('simplycap_website'),get_option('simplycap_key'));

    if ($simplycaptcha_get_success == 'false') {
        print 'There was an error: '.$simplycaptcha_get_error;
    } else {
	   echo '<p class="simplycap_block">';
	       echo '<label><input type="hidden" name="simplycaptcha-tag" value="'.$simplycaptcha_get_tag.'">'.$simplycaptcha_get_question.'?</label>';
   	       echo '<br />';
           echo '<input type="text" size="30" name="simplycaptcha-answer">';
           echo '<br />';
	       echo '<a href="http://www.simplycaptcha.com">SimplyCaptcha</a></p>';

    	return true;
        }
    }
}

function simplycap_comment_post($comment) {	

	if ( is_user_logged_in() && get_option('simplycap_hideregister') == 1) {
		return $comment;
    // skip captcha for comment replies from the admin menu
	} elseif ( isset( $_REQUEST['action'] ) && $_REQUEST['action'] == 'replyto-comment' && (check_ajax_referer('replyto-comment', '_ajax_nonce', false) || check_ajax_referer( 'replyto-comment', '_ajax_nonce-replyto-comment', false))) {
				// skip capthca
				return $comment;
	} else {
        $simplycaptcha_tag     = ( isset($_REQUEST['simplycaptcha-tag']) ) ? trim($_REQUEST['simplycaptcha-tag']) : null;
        $simplycaptcha_answer  = ( isset($_REQUEST['simplycaptcha-answer']) ) ? trim($_REQUEST['simplycaptcha-answer']) : null;
        
	   if ( '' == $simplycaptcha_answer ) {
            wp_die( __('<strong>ERROR</strong>: Please answer the capcha.') ); 
        } else {
            global $simplycaptcha_validate_error,$simplycaptcha_validate_success;
            
            simplycaptcha_validate(get_option('simplycap_website'),$simplycaptcha_tag,$simplycaptcha_answer);
                
                if ($simplycaptcha_validate_success =='false') {
                    wp_die( __('<strong>ERROR</strong>: That answer to the capcha is incorrect.') );
                } else {
                    return($comment);
                }
        }
    }
}


///adds to login - not working
function simplycap_login_form() {
    if( session_id() == "" ) {session_start();}	
    ////Call SimplyCaptcha Function
    simplycaptcha_get(get_option('simplycap_website'),get_option('simplycap_key'));
    global $simplycaptcha_get_question,$simplycaptcha_get_tag,$simplycaptcha_get_error,$simplycaptcha_get_success;
    
    if ($simplycaptcha_get_success == 'false') {
        print 'There was an error: '.$simplycaptcha_get_error;
    } else {
	   echo '<p class="simplycap_block">';
       	
	if( isset( $_SESSION['simplycap_error'] ) ) {
		echo "<br /><span style='color:red'>". $_SESSION['simplycap_error'] ."</span><br />";
		unset( $_SESSION['simplycap_error'] );
	}
    
	       echo '<label><input type="hidden" name="simplycaptcha-tag" value="'.$simplycaptcha_get_tag.'">'.$simplycaptcha_get_question.'?</label>';
   	       echo '<br />';
           echo '<input type="text" size="30" name="simplycaptcha-answer">';
           echo '<br /><a href="http://www.simplycaptcha.com">SimplyCaptcha</a>';
	       echo '</p>';

    	return true;
    }  

}


function simplycap_login_post($errors) {

    $simplycaptcha_tag     = ( isset($_REQUEST['simplycaptcha-tag']) ) ? trim($_REQUEST['simplycaptcha-tag']) : null;
    $simplycaptcha_answer  = ( isset($_REQUEST['simplycaptcha-answer']) ) ? trim($_REQUEST['simplycaptcha-answer']) : null;
	// Delete errors, if they set
	if( isset( $_SESSION['simplycap_error'] ) )
		unset( $_SESSION['simplycap_error'] );

	if( isset( $_REQUEST['action'] ) && 'register' == $_REQUEST['action'] )
		return($errors);

	// If captcha not complete, return error
	if ($simplycaptcha_answer == "") {	
		return $errors.'<strong>'. __( 'ERROR', 'captcha' ) .'</strong>: '. __( 'Please complete the CAPTCHA.', 'captcha' );	

    } else {
        global $simplycaptcha_validate_error,$simplycaptcha_validate_success;
        simplycaptcha_validate(get_option('simplycap_website'),$simplycaptcha_tag,$simplycaptcha_answer);
        
        if ($simplycaptcha_validate_success =='false') {
                   	return $errors.'<strong>'. __( 'ERROR', 'captcha' ) .'</strong>: '. __( 'That CAPTCHA was incorrect.', 'captcha' );
                }      
    }
    return($errors);
} 

// this function checks the captcha posted with a login when login errors are absent
function simplycap_login_check($url) {
	global $simplycaptcha_validate_error,$simplycaptcha_validate_success;
    
    if( session_id() == "" ) {session_start();}
    
    $simplycaptcha_tag     = (isset($_REQUEST['simplycaptcha-tag'])) ? trim($_REQUEST['simplycaptcha-tag']) : null;
  //$simplycaptcha_answer  = (isset($_REQUEST['simplycaptcha-answer'])) ? trim($_REQUEST['simplycaptcha-answer']) : null; 
    $simplycaptcha_answer = $_REQUEST['simplycaptcha-answer'];
    
   	if ($simplycaptcha_answer == "") {	
	$_SESSION['simplycap_error'] = __( 'Please complete the CAPTCHA.'.$simplycaptcha_answer.'0', 'captcha' );
    return $_SERVER["REQUEST_URI"];
    } else {
    simplycaptcha_validate(get_option('simplycap_website'),$simplycaptcha_tag,$simplycaptcha_answer);
	   
        if ($simplycaptcha_validate_success == 'false') {
		$_SESSION['simplycap_error'] = __( 'Please complete the CAPTCHaaA.', 'captcha' );
		// Redirect to wp-login.php
		wp_clear_auth_cookie();
		return $_SERVER["REQUEST_URI"];
	   } elseif ($simplycaptcha_validate_success =='true') {
	      unset ($_SESSION['simplycap_error']);
		  return $url;
       }
    }
}

// this function adds the captcha to the register form
function simplycap_register_form() {
    ////Call SimplyCaptcha Function
    simplycaptcha_get(get_option('simplycap_website'),get_option('simplycap_key'));
    global $simplycaptcha_get_question,$simplycaptcha_get_tag,$simplycaptcha_get_error,$simplycaptcha_get_success;
    
    if ($simplycaptcha_get_success == 'false') {
        print 'There was an error: '.$simplycaptcha_get_error;
    } else {
	   echo '<p class="simplycap_block">';
	       echo '<label><input type="hidden" name="simplycaptcha-tag" value='.$simplycaptcha_get_tag.'>'.$simplycaptcha_get_question.'?</label>';
   	       echo '<br />';
           echo '<input type="text" size="30" name="simplycaptcha-answer">';
	       echo '<br /><a href="http://www.simplycaptcha.com">SimplyCaptcha</a></p>';

    	return true;
        }
}


function simplycap_register_post($login,$email,$errors) {
    global $simplycaptcha_validate_error,$simplycaptcha_validate_success;
    
    $simplycaptcha_tag     = ( isset($_REQUEST['simplycaptcha-tag']) ) ? trim($_REQUEST['simplycaptcha-tag']) : null;
    $simplycaptcha_answer  = ( isset($_REQUEST['simplycaptcha-answer']) ) ? trim($_REQUEST['simplycaptcha-answer']) : null; 

	// If captcha is blank - add error
    if ($simplycaptcha_answer == "") {
		$errors->add('captcha_blank', '<strong>'.__('ERROR', 'captcha').'</strong>: '.__('Please complete the CAPTCHA.', 'captcha'));
		return $errors;
	} else {
	   simplycaptcha_validate(get_option('simplycap_website'),$simplycaptcha_tag,$simplycaptcha_answer);
	   
        if ($simplycaptcha_validate_success =='false') {
            $errors->add('captcha_wrong', '<strong>'.__('ERROR', 'captcha').'</strong>: '.__('That CAPTCHA was incorrect.', 'captcha'));              
            }
	}
  return($errors);
} 

function simplycap_register_validate($results) {
    global $simplycaptcha_validate_error,$simplycaptcha_validate_success;
    
    $simplycaptcha_tag     = ( isset($_REQUEST['simplycaptcha-tag']) ) ? trim($_REQUEST['simplycaptcha-tag']) : null;
    $simplycaptcha_answer  = ( isset($_REQUEST['simplycaptcha-answer']) ) ? trim($_REQUEST['simplycaptcha-answer']) : null; 
    
	if ($simplycaptcha_answer == "") {
		$results['errors']->add('captcha_blank', '<strong>'.__('ERROR', 'captcha').'</strong>: '.__('Please complete the CAPTCHA.', 'captcha'));
		return $results;
	} else {
	    simplycaptcha_validate(get_option('simplycap_website'),$simplycaptcha_tag,$simplycaptcha_answer);
        
            if ($simplycaptcha_validate_success =='false') {
            $results['errors']->add('captcha_wrong', '<strong>'.__('ERROR', 'captcha').'</strong>: '.__('That CAPTCHA was incorrect.', 'captcha'));            
            }
	}
  return($results);
} 

// this function checks the captcha posted with lostpassword form
function simplycap_lostpassword_post() {
    global $simplycaptcha_validate_error,$simplycaptcha_validate_success;
    
    $simplycaptcha_tag     = ( isset($_REQUEST['simplycaptcha-tag']) ) ? trim($_REQUEST['simplycaptcha-tag']) : null;
    $simplycaptcha_answer  = ( isset($_REQUEST['simplycaptcha-answer']) ) ? trim($_REQUEST['simplycaptcha-answer']) : null; 
    
	// If field 'user login' is empty - return
	if( isset( $_REQUEST['user_login'] ) && "" == $_REQUEST['user_login'] ) {
		return;
    } elseif ($simplycaptcha_answer == "") {
		wp_die( __( 'Please complete the CAPTCHA.', 'captcha' ) );
	} else {
	    simplycaptcha_validate(get_option('simplycap_website'),$simplycaptcha_tag,$simplycaptcha_answer);
        
            if ($simplycaptcha_validate_success =='false') {
            wp_die( __( 'Error: You entered in the wrong CAPTCHA phrase. Press your browser\'s back button and try again.', 'captcha' ) );            
            } elseif ($simplycaptcha_validate_success =='true') {
               return; 
            }
	}
} 

////add menu tab
add_action('admin_menu', 'simplycap_ul_menu');
function simplycap_ul_menu() { add_menu_page("SimplyCaptcha", "SimplyCaptcha", 0, "simplycaptcha", "simplycap_options_page", SIMPLYCAP_URL."/images/icon.png", 1000);
}


function simplycap_options_page() {
?>
<div class="wrap">
<h1>SimplyCaptcha Settings</h1>
Don't have a key? <a href="http://www.simplycaptcha.com" target="_blank">Go here</a>, register your website and get a key!
<form method="post" action="options.php">
    <?php settings_fields( 'simplycap-settings-group' ); ?>
    <table class="form-table">
        <tr valign="top">
        <th scope="row">Key</th>
        <td><input type="text" name="simplycap_key" value="<?php echo get_option('simplycap_key'); ?>" /></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Website</th>
        <td><input type="text" name="simplycap_website" value="<?php echo get_option('simplycap_website'); ?>" /></td>
        </tr>
    
        <tr valign="top">
        <th scope="row">Register Form</th>
        <?php if (get_option('simplycap_registerform') == '1') {$regtrue = 'selected';} else {$regtrue='';} if (get_option('simplycap_registerform') == '0') {$regfalse = 'selected';} else {$regfalse='';} ?>
        <td><select name="simplycap_registerform"><option value="1" <?php print $regtrue;?> >On</option><option value="0" <?php print $regfalse; ?> >Off</option></select></td>
        </tr>
    
        <tr valign="top">
        <th scope="row">Comment Form</th>
        <?php if (get_option('simplycap_commentform') == '1') {$commenttrue = 'selected';} else {$commenttrue='';} if (get_option('simplycap_commentform') == '0') {$commentfalse = 'selected';} else {$commentfalse='';}  ?>
        <td><select name="simplycap_commentform"><option value="1" <?php print $commenttrue;?> >On</option><option value="0" <?php print $commentfalse; ?> >Off</option></select></td>
        </tr>
         
        <tr valign="top">
        <th scope="row">Lost Password Form</th>
        <?php if (get_option('simplycap_lostpassform') == '1') {$losttrue = 'selected';} else {$losttrue='';} if (get_option('simplycap_lostpassform') == '0') {$lostfalse = 'selected';} else {$lostfalse='';}  ?>
        <td><select name="simplycap_lostpassform"><option value="1" <?php print $losttrue;?> >On</option><option value="0" <?php print $lostfalse; ?> >Off</option></select></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Login Form<br />(Not Working)</th>
        <?php if (get_option('simplycap_loginform') == '1') {$logintrue = 'selected';} else {$logintrue='';} if (get_option('simplycap_loginform') == '0') {$loginfalse = 'selected';} else {$loginfalse='';}  ?>
        <td>Off</td>
        <!--- <td><select name="simplycap_loginform"><option value="1" <?php print $logintrue;?> >On</option><option value="0" <?php print $loginfalse; ?> >Off</option></select></td> --!>
        </tr>
        
        <tr valign="top">
        <th scope="row">Hide if registered</th>
        <?php if (get_option('simplycap_hideregister') == '1') {$hidetrue = 'selected';} else {$hidetrue='';} if (get_option('simplycap_hideregister') == '0') {$hidefalse = 'selected';} else {$hidefalse='';}  ?>
        <td><select name="simplycap_hideregister"><option value="1" <?php print $hidetrue;?> >On</option><option value="0" <?php print $hidefalse; ?> >Off</option></select></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Use Bot/IP Security</th>
        <?php if (get_option('simplycap_usesecurity') == '1') {$sectrue = 'selected';} else {$sectrue='';} if (get_option('simplycap_usesecurity') == '0') {$secfalse = 'selected';} else {$secfalse='';}  ?>
        <td><select name="simplycap_usesecurity"><option value="1" <?php print $sectrue;?> >On</option><option value="0" <?php print $secfalse; ?> >Off</option></select></td>
        </tr>
        
    </table>
    
    <p class="submit">
    <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
    </p>

</form>
</div>
<?
}
?>